#ifndef _CHAMBER_H_
#define _CHAMBER_H_

using namespace std;

enum {X, Y, Z}; // coordinate : globally useful

class Chamber
{
public:
    virtual ~Chamber(){}

    virtual int isInside(const double *r) const = 0;
    virtual int isOutside(const double *r) const = 0;

    virtual double radius() const = 0;

    virtual void advance(double time) = 0;
    virtual double detect(const double *r, const double *v, double best_time, double gravity) = 0;
    virtual void collide(const double *r, double *v) = 0;
};
#endif
