#include "chamber.h"

using namespace std;

class Cylinder
    : public Chamber
{
    double radius_, radius2_, radius_inv_;
    double height_;

    double
        coef_st_,
        coef_sw_,
        vr_min_;// minimum allowed radial velocity during wall collision

// sawtooth motion of the base : constants
    double base_amplitude_;
    double base_period_, base_period_half_;
    double base_velocity_, base_velocity_inv_;

// sawtooth motion of the base : variables
    double base_z_;
    int base_dir_;

    int col_type_;

// collision counters
    int col_st_;
    int col_sb_;
    int col_sw_;
public :
    Cylinder(const char* filename);
    ~Cylinder();

    double radius() const;
    double height() const;

    int isInside(const double *r) const;
    int isOutside(const double *r) const;

    void advance(double time);
    double detect(const double *r, const double *v, double best_time, double gravity);
    void collide(const double *r, double *v);

};
inline double Cylinder::radius() const {return radius_;}
inline double Cylinder::height() const {return height_;}
