#include "experiment.h"
#include "timer.h"
//#include "timerc.h"
#include <iostream>

using namespace std;

Experiment::Experiment(Shot& shot, Chamber& chamber, const Par& par)
: shot_(shot)
, chamber_(chamber)

, gravity_(par.gravity())
, tstep_(par.tStep())
, ncolmax_(par.ncolmax())
, collisions_(0)
{
    shot_.distribute(chamber_);
    shot_.detect();
    shot_.correct(chamber_, gravity_);
}

Experiment::~Experiment(){}

void
Experiment::makeStep(double tmax)
{
    while (shot_.tNext() < tmax){
        tmax-= shot_.tNext();
// GO TO DETECTED COLLISION
        chamber_.advance(shot_.tNext());
        shot_.advance(shot_.tNext(), gravity_);

//        shot_.test(chamber_);

// PROCEED TO COLLISION
        shot_.collide(chamber_); ++collisions_;
// DETECT NEXT COLLISION
        shot_.detect(); // detect sphere-sphere collisions
        shot_.correct(chamber_, gravity_); // take chamber impacts into account
//cout<< tmax <<' ';
//if (!(collisions_%10000)) cout << collisions_ << endl;
    }
//cout<<shot_.tNext()<<endl;
    chamber_.advance(tmax);
    shot_.advance(tmax, gravity_);
}

void
Experiment::fullRun()
{
    collisions_= 0;
    unsigned istep;
    Timer timer("cpu");
    for(istep=0;collisions_<ncolmax_;++istep){
        unsigned collisions= collisions_;
//        Timer timer("cpu");
        makeStep(tstep_*1000);
//        cout<< istep <<' '<< collisions_ <<' '<< timer  <<' '<< timer/(collisions_-collisions) <<endl;
//        cin.get();
    }
    cout << collisions_ <<" collisions were computed in "<< timer <<" seconds"<< endl;
}
